// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_close.c $
// $Rev: 19616 $
// $Date: 2012-11-03 16:41:25 -0500 (Sat, 03 Nov 2012) $

// INtime 4 driver

#include "main.h"



//*****************************************************************************
int os_close(GSC_ALT_STRUCT_T* alt)
{
	int	ret;

	for (;;)	// A convenience loop.
	{
		if (alt == NULL)
		{
			// The referenced device doesn't exist.
			ret	= -ENODEV;
			break;
		}

		ret	= os_sem_lock(&gsc_global.sem);

		if (ret < 0)
		{
			printf("%s: Failed to acquire master device lock.\n", DEV_NAME);
			break;
		}

		ret	= gsc_close(alt);
		os_sem_unlock(&gsc_global.sem);
		break;
	}

	return(ret);
}


