// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_irq.c $
// $Rev: 26098 $
// $Date: 2014-05-16 10:50:37 -0500 (Fri, 16 May 2014) $

// INtime 4 driver

#include "main.h"



//*****************************************************************************
static __INTERRUPT void _irq_isr(void)
{
	int		i;
	WORD	level;

	__INTERRUPT_PROLOG();
	level	= GetRtInterruptLevel();
	EnterRtInterrupt(level);
	knStopRtScheduler();

	for (i = 0; i < ARRAY_ELEMENTS(gsc_global.dev_list); i++)
	{
		if ((gsc_global.dev_list[i]) &&
			(gsc_global.dev_list[i]->irq.irq.irq_level == level))
		{
			gsc_irq_isr_common(gsc_global.dev_list[i]);
			break;
		}
	}

	SignalEndOfRtInterrupt(level);
	knStartRtScheduler();
	__INTERRUPT_RETURN();
}



//*****************************************************************************
int os_irq_acquire(dev_data_t* dev)
{
	int		ret	= -EIO;
	BOOL	sts;

	if (dev->irq.irq.active == 0)
	{
		dev->irq.irq.active		= 1;
		dev->irq.irq.irq_level	= PciGetInterruptLevel(&dev->pci->pcidev);

		sts	= SetRtInterruptHandler(dev->irq.irq.irq_level, 0, _irq_isr);

		if (sts == TRUE)
		{
			ret	= 0;
		}
		else
		{
			dev->irq.irq.active		= 0;
			ret						= -EIO;
		}
	}

	return(ret);
}



//*****************************************************************************
void os_irq_disable(dev_data_t* dev)
{
	DisableRtInterrupt(dev->irq.irq.irq_level);
}



//*****************************************************************************
void os_irq_enable(dev_data_t* dev)
{
	EnableRtInterrupt(dev->irq.irq.irq_level);
}



//*****************************************************************************
void os_irq_release(dev_data_t* dev)
{
	if (dev->irq.irq.active)
	{
		dev->irq.irq.active	= 0;
		ResetRtInterruptHandler(dev->irq.irq.irq_level);
	}
}


