// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/driver/intime/os_main.c $
// $Rev: 23057 $
// $Date: 2013-08-29 10:14:16 -0500 (Thu, 29 Aug 2013) $

// INtime 4 driver

#include "main.h"



// variables ******************************************************************

static	int	_exit	= 0;
static	int	_help	= 0;



//*****************************************************************************
static void _parse_args(int argc, char** argv)
{
	int	i;

	for (i = 1; i < argc; i++)
	{
		if (strcmp(argv[i], "-h") == 0)
		{
			_help	= 1;
			continue;
		}

		if (strcmp(argv[i], "-x") == 0)
		{
			_exit	= 1;
			continue;
		}

		_help	= 1;
		printf("ERROR: invalid argument: %s\n", argv[i]);
		break;
	}
}



//*****************************************************************************
static void _usage(void)
{
	printf("USAGE: sio4 <-h> <-u> <-x>\n");
	printf("   -h    Show this usage information.\n");
	printf("   -u    Uncatalog the driver's mailboxes. Requires -x.\n");
	printf("   -x    Tell the driver to exit.\n");
}



//*****************************************************************************
void main(int argc, char* argv[])
{
	int	ret;

	_parse_args(argc, argv);

	if (_help)
	{
		_usage();
	}
	else if (_exit)
	{
		printf("Initiating driver exit ... ");
		os_exit_initiate(EXIT_UNCAT);
		printf("Done\n");
	}
	else
	{
		ret	= os_root_mbox_create();

		if (ret == 0)
			ret	= os_init_driver();

		if (ret == 0)
			os_root_mbox_service();

		os_exit_driver();
		os_exit_initiate(EXIT_UNCAT);
	}
}


