// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/irq/main_dma.c $
// $Rev: 23197 $
// $Date: 2013-09-30 18:00:48 -0500 (Mon, 30 Sep 2013) $

#include "main.h"



//*****************************************************************************
static int _irq_check_support(int fd)
{
	return(STATUS_SUPPORTED);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	char	buf[200]	= "";
	int		errs		= 0;
	int		sts;

	// Generate a DMA interrupt.
	errs	+= sio4_initialize	(fd, -1, 0, 1, NULL);
	errs	+= sio4_tx_io_mode	(fd, -1, 0, GSC_IO_MODE_DMA, NULL);
	sts		= sio4_write(fd, buf, sizeof(buf));

	if ((sts == -1) || (sts != sizeof(buf)))
	{
		errs++;
		printf("ERROR: sio4_write() failure, errno = %d\n", errno);
	}

	return(errs);
}



//*****************************************************************************
int main_dma_irq_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


