// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/lib/intime/os_sem.c $
// $Rev: 26099 $
// $Date: 2014-05-16 10:51:54 -0500 (Fri, 16 May 2014) $

// INtime 4 library

#include "main.h"




//*****************************************************************************
// returns err_no: 0 = ok, !=0 = error value
int os_sem_create(os_sem_t* sem)
{
	int	err_no;

	for (;;)
	{
		if (sem == NULL)
		{
			err_no	= EINVAL;
			break;
		}

		memset(sem, 0, sizeof(os_sem_t));
		sem->sem	= CreateRtSemaphore(1, 1, FIFO_QUEUING);

		if (sem->sem == BAD_RTHANDLE)
		{
			err_no	= GetLastRtError();
			break;
		}

		err_no	= 0;
		break;
	}

	return(err_no);
}



//*****************************************************************************
void os_sem_destroy(os_sem_t* sem)
{
	if (sem)
	{
		if ((sem->sem != BAD_RTHANDLE) && (sem->sem != 0))
			DeleteRtSemaphore(sem->sem);

		memset(sem, 0, sizeof(os_sem_t));
	}
}



//*****************************************************************************
// returns err_no: 0 = ok, !=0 = error value
int os_sem_lock(os_sem_t* sem)
{
	int		err_no;
	DWORD	sts;

	for (;;)
	{
		if (sem == NULL)
		{
			err_no	= EINVAL;
			break;
		}

		sts	= WaitForRtSemaphore(sem->sem, 1, WAIT_FOREVER);

		if (sts == WAIT_FAILED)
		{
			err_no	= GetLastRtError();
			break;
		}

		err_no	= 0;
		break;
	}

	return(err_no);
}



//*****************************************************************************
void os_sem_unlock(os_sem_t* sem)
{
	if (sem)
		ReleaseRtSemaphore(sem->sem, 1);
}


