// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/utils/gsc_utils.h $
// $Rev: 25704 $
// $Date: 2014-03-31 16:38:21 -0500 (Mon, 31 Mar 2014) $

#ifndef __GSC_UTILS_H__
#define __GSC_UTILS_H__

#include "gsc_common.h"
#include "os_utils.h"



// data types *****************************************************************

typedef struct		// For listing register values.
{
	const char*	name;
	int			reg;
	int			err;
	u32			value;
	int			ask_support;	// Call below function for this.
	int			(*decode)(int fd, int supported, u32 value, int width);
	const char*	desc;			// Description
} gsc_reg_def_t;



// prototypes *****************************************************************

void		gsc_label(const char* label);
void		gsc_label_init(int width);
int			gsc_label_indent(int delta);
void		gsc_label_index(const char* label, int index);
void		gsc_label_level_dec(void);
void		gsc_label_level_inc(void);
void		gsc_label_long_comma(long long value);
void		gsc_label_long_comma_buf(long long value, char* buffer);
void		gsc_label_suffix(const char* label, const char* suffix);

const char*	gsc_reg_pex8111_get_desc(unsigned long reg);
const char*	gsc_reg_pex8111_get_name(unsigned long reg);
int			gsc_reg_pex8111_list_pci(int fd, int (reg_read)(int fd, u32 reg, u32* value));
int			gsc_reg_pex8111_list_plx(int fd, int (reg_read)(int fd, u32 reg, u32* value));

const char*	gsc_reg_pex8112_get_desc(unsigned long reg);
const char*	gsc_reg_pex8112_get_name(unsigned long reg);
int			gsc_reg_pex8112_list_pci(int fd, int (reg_read)(int fd, u32 reg, u32* value));
int			gsc_reg_pex8112_list_plx(int fd, int (reg_read)(int fd, u32 reg, u32* value));

const char*	gsc_reg_plx9056_get_desc(unsigned long reg);
const char*	gsc_reg_plx9056_get_name(unsigned long reg);
int			gsc_reg_plx9056_list_pci(int fd, int (reg_read)(int fd, u32 reg, u32* value));
int			gsc_reg_plx9056_list_plx(int fd, int (reg_read)(int fd, u32 reg, u32* value));

const char*	gsc_reg_plx9060es_get_desc(unsigned long reg);
const char*	gsc_reg_plx9060es_get_name(unsigned long reg);
int			gsc_reg_plx9060es_list_pci(int fd, int (reg_read)(int fd, u32 reg, u32* value));
int			gsc_reg_plx9060es_list_plx(int fd, int (reg_read)(int fd, u32 reg, u32* value));

const char*	gsc_reg_plx9080_get_desc(unsigned long reg);
const char*	gsc_reg_plx9080_get_name(unsigned long reg);
int			gsc_reg_plx9080_list_pci(int fd, int (reg_read)(int fd, u32 reg, u32* value));
int			gsc_reg_plx9080_list_plx(int fd, int (reg_read)(int fd, u32 reg, u32* value));

const char*	gsc_reg_plx9656_get_desc(unsigned long reg);
const char*	gsc_reg_plx9656_get_name(unsigned long reg);
int			gsc_reg_plx9656_list_pci(int fd, int (reg_read)(int fd, u32 reg, u32* value));
int			gsc_reg_plx9656_list_plx(int fd, int (reg_read)(int fd, u32 reg, u32* value));
int			gsc_select_1_dev(int qty, int* index, const char* name);
int			gsc_select_2_devs(int qty, int* index_1, int* index_2, const char* name);

void		gsc_reg_field_show(
				int				label_width,
				int				name_width,
				u32				value,
				int				hi_bit,
				int				low_bit,
				int				eol,
				const char**	list,
				const char*		name);

int			gsc_reg_list(
				int				fd,
				gsc_reg_def_t*	list,
				int				detail,
				int				(reg_read)(int fd, u32 reg, u32* value));



#endif
