// $URL: http://subversion:8080/svn/gsc/trunk/drivers/gsc_common/utils/intime/os_utils.h $
// $Rev: 22961 $
// $Date: 2013-08-26 14:46:33 -0500 (Mon, 26 Aug 2013) $

#ifndef __OS_UTILS_H__
#define __OS_UTILS_H__

// INtime

#include <errno.h>
#include <stdio.h>
#include <string.h>

#include "os_common.h"



// data types ***************************************************************

typedef	struct
{
	void*			key;
	KNHANDLE		handle;
	u8				sem_data[KN_SEMAPHORE_SIZE];
} os_sem_t;

typedef struct
{
	RTHANDLE	handle;
	char		name[64];
} os_thread_t;



// prototypes ***************************************************************

int		os_count_boards(const char* base_name);

int		os_id_driver(const char* base_name);
void	os_id_host(void);

int		os_sem_create(os_sem_t* sem);
int		os_sem_destroy(os_sem_t* sem);
int		os_sem_lock(os_sem_t* sem);
int		os_sem_unlock(os_sem_t* sem);

int		os_thread_create(os_thread_t* thread, const char* name, int (*function)(void* arg), void* arg);
int		os_thread_destroy(os_thread_t* thread);

void	os_sleep_ms(int ms);



#endif
