// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/utils/util_usc_hdlc_tx_l_chr_len.c $
// $Rev: 18173 $
// $Date: 2012-09-26 09:55:58 -0500 (Wed, 26 Sep 2012) $

#include "sio4_utils.h"



/******************************************************************************
*
*	Function:	sio4_usc_hdlc_tx_l_chr_len
*
*	Purpose:
*
*		Provide a visual wrapper for the SIO4_IOCTL_USC_HDLC_TX_L_CHR_LEN service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the board to access. Ignore if < 0.
*
*		verbose	0: errors only, !0: all output
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int sio4_usc_hdlc_tx_l_chr_len(int fd, int index, int verbose, s32 set, s32* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;

	if (verbose)
		gsc_label_index("USC HDLC Tx Last Char Length", index);

	errs	= sio4_dsl_ioctl(fd, SIO4_IOCTL_USC_HDLC_TX_L_CHR_LEN, &set);

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "This service is not supported by this board.";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_1:

			ptr	= "1-bit";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_2:

			ptr	= "2-bits";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_3:

			ptr	= "3-bits";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_4:

			ptr	= "4-bits";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_5:

			ptr	= "5-bits";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_6:

			ptr	= "6-bits";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_7:

			ptr	= "7-bits";
			break;

		case SIO4_USC_HDLC_TX_L_CHR_LEN_8:

			ptr	= "8-bits";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


